/*
 * CPSC 211 Lab 6
 */
package dna;

import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

/**
 * Represent a DNA Sequence
 * 
 * Class Invariants:
 *    sequence != null
 */
public class DNASequence {
    
    // Store the sequence as a linked list of Character
    // objects. Each item in the list is one nucleotide.
    // This is not the most efficient representation, but
    // it suffices for the purposes of this class.
    private List<Character> sequence;

    /**
     * Constructor
     */
    public DNASequence() {
        super();
        sequence = new ArrayList<Character>();
    }
    
    /**
     * Load a sequence from a file.
     * @param filename The name of the file containing 
     *     the nucleotides of the sequence
     */
    public void loadFromFile(String filename) 
        throws IOException {
        File inputFile = new File( filename );
        FileReader in = new FileReader( inputFile );
        
        int c;
        while ( ( c = in.read()) != -1 ) {
            sequence.add(new Character((char) c ));
        }
        in.close();
    }
    
    /**
     * Return the length of the sequence
     * @return The number of nucleotides in the sequence
     */
    public int length() {
        return sequence.size();
    }
    
    
}
